<?php
/**
* Plugin Name: Giants Dedi Server Status
* Plugin URI: http://www.farming-simulator.com/dlc-detail-fs13-ds.php
* Description: Displays GIANTS Dedicated Server status. First setup the plugin's configuration through the admin panel 'appearance -> widgets -> GIANTS Dedi....', then you can insert [serverlist] on any page to include a server list. 
* Author: GIANTS Software
* Author URI: http://www.giants-software.com/
* Version: 1.0
*/
/**
 * Dedicated Server Stats
 *
 * @author  Daniel Evans
 * @date  04/10/2013
 * 
 * Copyright (c) 2008-2013 GIANTS Software GmbH, Confidential, All Rights Reserved.
 * Copyright (c) 2003-2013 Christian Ammann and Stefan Geiger, Confidential, All Rights Reserved.
 */


function lsDediGetVehicleClass($category, $type) {
    if($category == 'vehicle') {
        return 'vehicle';
    } else if($category == 'harvester') {
        return 'harvester';
    } else if($category == 'tool') {
        return 'tool';
    } else if($category == 'trailer') {
        return 'trailer';
    } else if($category == 'tractors') {
        return 'vehicle';
    } else if($category == 'trucks') {
        return 'vehicle';
    } else if($category == 'wheelLoaders') {
        if($type == 'dynamicMountAttacherImplement') {
            return 'tool';
        } else if($type == 'shovel_animated') {
            return 'tool';
        } else if($type == 'shovel_dynamicMountAttacher') {
            return 'tool';
        } else {
            return 'vehicle';
        }
    } else if($category == 'teleLoaders') {
        if($type == 'dynamicMountAttacherImplement') {
            return 'tool';
        } else if($type == 'baleGrab') {
            return 'tool';
        } else if($type == 'shovel_dynamicMountAttacher') {
            return 'tool';
        } else if($type == 'shovel_animated') {
            return 'tool';
        } else {
            return 'vehicle';
        }
    } else if($category == 'skidSteers') {
        if($type == 'dynamicMountAttacherImplement') {
            return 'tool';
        } else if($type == 'shovel') {
            return 'tool';
        } else if($type == 'shovel_dynamicMountAttacher') {
            return 'tool';
        } else if($type == 'stumpCutter') {
            return 'tool';
        } else if($type == 'treeSaw') {
            return 'tool';
        } else {
            return 'vehicle';
        }
    } else if($category == 'cars') {
        return 'vehicle';
    } else if($category == 'harvesters') {
        return 'harvester';
    } else if($category == 'forageHarvesters') {
        if($type == 'attachableCombine') {
            return 'tool';
        } else {
            return 'harvester';
        }
    } else if($category == 'potatoHarvesting') {
        if($type == 'defoliator_animated') {
            return 'tool';
        } else {
            return 'harvester';
        }
    } else if($category == 'beetHarvesting') {
        if($type == 'defoliater_cutter_animated') {
            return 'tool';
        } else {
            return 'harvester';
        }
    } else if($category == 'frontLoaders') {
        if($type == 'wheelLoader') {
            return 'vehicle';
        } else {
            return 'tool';
        }
    } else if($category == 'forageHarvesterCutters') {
        return 'tool';
    } else if($category == 'cutters') {
        return 'tool';
    } else if($category == 'plows') {
        return 'tool';
    } else if($category == 'cultivators') {
        return 'tool';
    } else if($category == 'sowingMachines') {
        return 'tool';
    } else if($category == 'sprayers') {
        if($type == 'selfPropelledSprayer') {
            return 'vehicle';
        } else {
            return 'tool';
        }
    } else if($category == 'fertilizerSpreaders') {
        return 'tool';
    } else if($category == 'weeders') {
        return 'tool';
    } else if($category == 'mowers') {
        return 'tool';
    } else if($category == 'tedders') {
        return 'tool';
    } else if($category == 'windrowers') {
        return 'tool';
    } else if($category == 'baling') {
        if($type == 'transportTrailer') {
            return 'trailer';
        } else if($type == 'baleLoader') {
            return 'trailer';
        } else if($type == 'baler') {
            return 'trailer';
        } else {
            return 'tool';
        }
    } else if($category == 'chainsaws') {
        return 'tool';
    } else if($category == 'wood') {
        if($type == 'transportTrailer') {
            return 'trailer';
        } else if($type == 'forwarderTrailer_steerable') {
            return 'trailer';
        } else if($type == 'woodCrusherTrailer') {
            return 'trailer';
        } else if($type == 'combine_animated') {
            return 'vehicle';
        } else if($type == 'forwarder') {
            return 'vehicle';
        } else if($type == 'woodHarvester') {
            return 'vehicle';
        } else {
            return 'tool';
        }
    } else if($category == 'animals') {
        if($type == 'selfPropelledMixerWagon') {
            return 'vehicle';
        } else {
            return 'trailer';
        }
    } else if($category == 'leveler') {
        return 'tool';
    } else if($category == 'misc') {
        if($type == 'fuelTrailer') {
            return 'trailer';
        } else {
            return 'tool';
        }
    } else if($category == 'dollys') {
        return 'trailer';
    } else if($category == 'weights') {
        return 'tool';
    } else if($category == 'pallets') {
        return 'tool';
    } else if($category == 'belts') {
        return 'tool';
    } else if($category == 'placeables') {
        return 'tool';
    } else if($category == 'tippers') {
        return 'trailer';
    } else if($category == 'augerWagons') {
        return 'trailer';
    } else if($category == 'slurryTanks') {
        if($type == 'manureBarrelCultivator') {
            return 'tool';
        } else {
            return 'trailer';
        }
    } else if($category == 'manureSpreaders') {
        return 'trailer';
    } else if($category == 'loaderWagons') {
        return 'trailer';
    } else if($category == 'lowloaders') {
        return 'trailer';
    } else if($category == 'cutterTrailers') {
        return 'trailer';
    } else {
        return 'tool';
    }
}

function serverstats_init() {
    $plugin_dir = dirname( plugin_basename( __FILE__ ) );
    load_plugin_textdomain( 'dedi-server-stats', false, $plugin_dir );
}
add_action('plugins_loaded', 'serverstats_init');

/** Utility Methods */
function loadFileHTTPSocket($domain, $port, $path, $timeout) {
    $fp = fsockopen($domain, $port, $errno, $errstr, $timeout);
    
    if ($fp) {
        // Make request
        $out = "GET ". $path . " HTTP/1.0\r\n";
        $out .= "Host: ". $domain . "\r\n";
        $out .= "Connection: Close\r\n\r\n";
        fwrite($fp, $out);
       
        // Get response
        $resp = "";
        while (!feof($fp)) {
            $resp .= fgets($fp, 256);
        }
        fclose($fp);
                    
        // Check status is 200
        if(preg_match("/HTTP\/1\.\d\s(\d+)/", $resp, $matches) && $matches[1] == 200) {   
            // Load xml as object
            $parts = explode("\r\n\r\n", $resp);
            $temp = "";
            for ($i=1;$i<count($parts);$i++) {
                $temp .= $parts[$i];
            }
            
            return $temp;
        }
    }
    return false;
}

function getServerStatsSimpleXML($id, $server) {
    $url = strtolower($server);
    if(substr($url, 0, 7) == "http://") {
        $url = substr($url, 7);
    }
    $data = explode('/', $url, 2);
    $data_host = explode(":", $data[0]);
    $port = 80;
    $host = $data_host[0];
    if(count($data_host) > 1) {
        $port = $data_host[1];
    }
    $stats_url = "/{$data[1]}";
    $cacheFile = "dedicated-server-stats-{$id}-{$host}-{$port}.cached";
    $cacheTimeout = 60*2;
    if(file_exists($cacheFile) && filemtime($cacheFile) > (time() - ($cacheTimeout + rand(0, 10)))) {
        $xmlStr = file_get_contents($cacheFile);
    } else {
        error_reporting(0);
        $xmlStr = loadFileHTTPSocket($host, $port, $stats_url, 4);
        error_reporting(E_ALL);
        
        if ($xmlStr) {
            $fp = fopen($cacheFile, "w");
            fwrite($fp, $xmlStr);
            fclose($fp);            
        }
    }
    
    return simplexml_load_string($xmlStr);
}


class DediServerStatusWidget extends WP_Widget {
    function __construct() {
        parent::__construct( 
            'server_status_widget', 
            __('GIANTS Dedi Server Status', 'dedi-server-stats') ,
            array( 'description' => __('Widget that displays Dedi Server Status', 'dedi-server-stats'))
        );
    }
    
    public function widget($args, $instance) {
        if ( !empty($instance['server_address']) ) { // and !empty($instance['title']) ) {
        
            $title = $instance['title'];
            $server = $instance['server_address'];
            $list_mods = $instance['list_mods'];
            $show_details = $instance['show_details'];
            $list_players = $instance['list_players'];
            $list_vehicles = $instance['list_vehicles'];
            $show_map = $instance['show_map'];
            $display_map_size = floatval( $instance['display_map_size'] );            
            $display_map_size = min( 4096, max( 64, $display_map_size ) );
            $in_server_list = 'server-list-sidebar' == $args['id'];      
        
            $data = getServerStatsSimpleXML( $args['widget_id'], $server );
            
            if ($data && (! empty($data->Slots))) {
                echo '<strong>'.__('Name', 'dedi-server-stats').':</strong> ' . $data['name'] . '<br/>';
                echo '<strong>'.__('Game', 'dedi-server-stats').':</strong> ' . $data['game'] . '<br/>';
                $usedSlots = 0; 
                $totalSlots = count($data->Slots->Player);
                foreach ($data->Slots->Player as $player) {
                    if ( $player['isUsed'] != "true" ) continue;
                    $usedSlots++;
                }
                echo '<strong>'.__('Players', 'dedi-server-stats').':</strong> ' . "{$usedSlots}/{$totalSlots}" . '<br/>';
                echo '<strong>'.__('Map', 'dedi-server-stats').':</strong> ' . $data['mapName'] . '<br/>';
                echo '<strong>'.__('Money', 'dedi-server-stats').':</strong> ' . $data['money'] . ' ' .__('$', 'dedi-server-stats'). '<br/>';
                echo '<strong>'.__('Server', 'dedi-server-stats').':</strong> ' . $data['server'] . '<br/>';
                if ($show_details) {
                    if ($list_players ) { //$usedSlots > 0) {
                        echo '<table' . ($in_server_list ? '' : ' style="width: 100%"') . '><thead>';
                        echo '<th>'.__('Player', 'dedi-server-stats').'</th>';
                        echo '<th>'.__('Time', 'dedi-server-stats').'</th>';
                        if($in_server_list) {
                            echo '<th>'.__('Admin', 'dedi-server-stats').'</th>';
                        }
                        echo '</thead><tbody>';
                        foreach ($data->Slots->Player as $player) {
                            if ( $player['isUsed'] != "true" ) continue; ?>
                            <tr>
                                <td><?php echo $player; ?></td>
                                <?php $hours = floor($player["uptime"]/60); $minutes = floor($player["uptime"]-($hours*60)); ?>
                                <td><?php echo "{$hours}h {$minutes}m"; ?></td>
                                <?php if($in_server_list) { ?>
                                <td><?php echo (($player["isAdmin"] == "true")?__('Yes', 'dedi-server-stats'):__('No', 'dedi-server-stats')); ?></td>
                                <?php } ?>
                            </tr>
                        <?php }
                        echo '</table>';
                    }
                    if ($show_map && $in_server_list ) {
                        // create link to image
                        $linkToImage = str_replace( "dedicated-server-stats.xml", "dedicated-server-stats-map.jpg", $server );
                        $imageSize = 1024;
                        $imageQuality = 90;
                        $mapSize = floatval($data["mapSize"]);
                        $mapSizeHalf = $mapSize / 2.0;
                        $linkToImage = $linkToImage . "&quality=90&size=1024";
                        
                        $machineIconSize = 10;
                        
                        echo "<div id=\"mapContainer\" style=\"position:relative; width:" . $display_map_size . "px; height:" . $display_map_size . "px; overflow:auto\"  >";
                        echo "<img src=\"" . $linkToImage . "\" width=\"" . $display_map_size . "px\" height=\"" . $display_map_size . "px\" />";   
                        echo "<div id=\"mapElementsContainer\" >";
                        $i=0;
                        foreach ($data->Vehicles->Vehicle as $veh) {
                            $i++;

                            $x = ($veh["x"] + $mapSizeHalf) / ($mapSize / $display_map_size);
                            $z = ($veh["z"] + $mapSizeHalf) / ($mapSize / $display_map_size);

                            $x = $x - ($machineIconSize-1)/2;
                            $z = $z - ($machineIconSize-1)/2;

                            $category = lsDediGetVehicleClass($veh["category"], $veh["type"]);

                            $icon = plugins_url("icons/" . $category . ".png", __FILE__);
                            $iconHover = plugins_url("icons/" . $category . "_selected.png", __FILE__);
                            $backgroundColor = "#4dafd7";

                            printf("<div id=\"vehicle%dContainer\" style=\"position:absolute; left: %dpx; top: %dpx;\" onmouseout=\"document.getElementById('vehicle%d').style.display='none'; document.getElementById('vehicle%dImage').src='%s'; document.getElementById('vehicle%dContainer').style.zIndex=1;\" onmouseover=\"document.getElementById('vehicle%d').style.display='block'; document.getElementById('vehicle%dImage').src='%s'; document.getElementById('vehicle%dContainer').style.zIndex=10; \" >
                                    <image id=\"vehicle%dImage\" src=\"%s\" width=\"%d\" height=\"%d\" />
                                    <div id=\"vehicle%d\" style=\"display:none; position:absolute; bottom:0px; left:%dpx; background:%s; padding-left:8px; padding-right:8px; color: #ffffff; \">
                                    <nobr>%s</nobr>
                                    </div>
                                    </div>", $i,  $x, $z, $i, $i, $icon, $i, $i, $i, $iconHover, $i, $i, $icon, $machineIconSize, $machineIconSize, $i, $machineIconSize+1, $backgroundColor, $veh["name"]);
                        }                            
                        echo "</div>";
                        echo "</div><br/>";
                        
                    }
                    if ($list_mods && $in_server_list && count($data->Mods->Mod) > 0) {
                        echo '<table><thead>';
                        echo '<th>'.__('Mod', 'dedi-server-stats').'</th>';
                        echo '<th>'.__('Author (Version)', 'dedi-server-stats').'</th>';
                        echo '</thead><tbody>';
                        foreach ($data->Mods->Mod as $mod) { ?>
                            <tr>
                                <td><?php echo $mod; ?></td>
                                <td><?php echo $mod["author"]; ?> (v<?php echo $mod["version"]; ?>)</td>
                            </tr>
                        <?php }
                        echo '</table>';
                    }
                    if ($list_vehicles && $in_server_list ) {
                        echo '<table cellspacing="7">';
                        echo '<tr><th>Vehicle</th><th>Category</th><th>Typ</th><th>Fill Levels</th><th>Fill Types</th></tr>';
                        foreach ($data->Vehicles->Vehicle as $veh) {
                            echo '<tr><td>' . $veh["name"] . '</td><td>' . $veh["category"] . '</td><td>' . $veh["type"] . '</td><td>' . $veh["fillLevels"] . '</td><td>' . $veh["fillTypes"] .'</td></tr>';
                        }
                        echo '</table>';
                    }    
                }
                else {  // no details!
                    if ($list_players) {
                        echo '<strong>'.__('Players', 'dedi-server-stats').':</strong>';
                        if($usedSlots > 0) {
                            echo '<ul>';
                            foreach ($data->Slots->Player as $player) {
                                if ( $player['isUsed'] != "true" ) continue;
                                echo "<li>{$player}</li>";
                            }
                            echo '</ul>';
                        }
                    }
                    if ($list_mods && $in_server_list) {
                        echo '<strong>'.__('Mods', 'dedi-server-stats').'</strong>';
                        if(count($data->Mods->mod) > 0) {
                            echo '<ul>';
                            foreach ($data->Mods->Mod as $mod) {
                                echo "<li>{$mod}</li>";
                            }
                            echo '</ul>';
                        }
                    } 
                }   
                echo '<p>Powered by <a href="http://www.giants-software.com">GIANTS Software</a>.</p>';
            }
            else {
                echo '<p>'.__('Server Unavailable').'.</p>';
            }
        } 
        
        echo $args['after_widget'];
    }
    
    public function form( $instance ) {
        if ( isset( $instance[ 'server_address' ] ) ) {
            $address = $instance[ 'server_address' ];
        }
        else { $address = ''; }
        if ( isset( $instance[ 'title' ] ) ) {
            $title = $instance[ 'title' ];
        }
        else { $title = ''; }
        if ( isset( $instance[ 'list_mods' ] ) ) {
            $list_mods = $instance[ 'list_mods' ];
        }
        else { $list_mods = FALSE; }
        if ( isset( $instance[ 'list_players' ] ) ) {
            $list_players = $instance[ 'list_players' ];
        }
        else { $list_players = FALSE; }
        if ( isset( $instance[ 'list_vehicles' ] ) ) {
            $list_vehicles = $instance[ 'list_vehicles' ];
        }
        else { $list_vehicles = FALSE; }        
        if ( isset( $instance[ 'show_map' ] ) ) {
            $show_map = $instance[ 'show_map' ];
        }
        else { $show_map = FALSE; }         
        if ( isset( $instance[ 'display_map_size' ] ) ) {
            $display_map_size = $instance[ 'display_map_size' ];
        }
        else { $display_map_size = "512"; }            
        if ( isset( $instance[ 'show_details' ] ) ) {
            $show_details = $instance[ 'show_details' ];
        }
        else { $show_details = FALSE; }
        ?>
        <p>
        <label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
        </p>
        <p>
        <label for="<?php echo $this->get_field_id( 'server_address' ); ?>"><?php _e( 'Server Stats URL feed', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'server_address' ); ?>" name="<?php echo $this->get_field_name( 'server_address' ); ?>" type="text" value="<?php echo esc_attr( $address ); ?>" />
        </p>
        <p>
        <label for="<?php echo $this->get_field_id( 'list_players' ); ?>"><?php _e( 'List Players', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'list_players' ); ?>" name="<?php echo $this->get_field_name( 'list_players' ); ?>" type="checkbox" <?php checked($list_players); ?> />
        </p>
        <p>
        <label for="<?php echo $this->get_field_id( 'list_mods' ); ?>"><?php _e( 'List Mods', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'list_mods' ); ?>" name="<?php echo $this->get_field_name( 'list_mods' ); ?>" type="checkbox" <?php checked($list_mods); ?> />
        </p>
        <p>
        <label for="<?php echo $this->get_field_id( 'list_vehicles' ); ?>"><?php _e( 'List Vehicles', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'list_vehicles' ); ?>" name="<?php echo $this->get_field_name( 'list_vehicles' ); ?>" type="checkbox" <?php checked($list_vehicles); ?> />
        </p>  
        <p>
        <label for="<?php echo $this->get_field_id( 'show_map' ); ?>"><?php _e( 'Show Map', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'show_map' ); ?>" name="<?php echo $this->get_field_name( 'show_map' ); ?>" type="checkbox" <?php checked($show_map); ?> />
        </p>            
        <p>
        <label for="<?php echo $this->get_field_id( 'display_map_size' ); ?>"><?php _e('Displayed map size:', '512'); ?></label>
        <input id="<?php echo $this->get_field_id( 'display_map_size' ); ?>" name="<?php echo $this->get_field_name( 'display_map_size' ); ?>" value="<?php echo $instance['display_map_size']; ?>" style="width:100%;" />
        </p>        
        <p>
        <label for="<?php echo $this->get_field_id( 'show_details' ); ?>"><?php _e( 'Show Details', 'dedi-server-stats' ); ?>:</label> 
        <input class="widefat" id="<?php echo $this->get_field_id( 'show_details' ); ?>" name="<?php echo $this->get_field_name( 'show_details' ); ?>" type="checkbox" <?php checked($show_details); ?> />
        </p>
        <?php 
    }

    public function update( $new_instance, $old_instance ) {
        $instance = $old_instance; //array();
        $instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
        $instance['server_address'] = ( ! empty( $new_instance['server_address'] ) ) ? strip_tags( $new_instance['server_address'] ) : '';
        $instance['list_mods'] = ( ! empty( $new_instance['list_mods'] ) ) ? $new_instance['list_mods'] == TRUE : FALSE;
        $instance['list_players'] = ( ! empty( $new_instance['list_players'] ) ) ? $new_instance['list_players'] == TRUE : FALSE;
        $instance['list_vehicles'] = ( ! empty( $new_instance['list_vehicles'] ) ) ? $new_instance['list_vehicles'] == TRUE : FALSE;
        $instance['show_map'] = ( ! empty( $new_instance['show_map'] ) ) ? $new_instance['show_map'] == TRUE : FALSE;
        $instance['display_map_size'] = strip_tags( $new_instance['display_map_size'] );
        $instance['show_details'] = ( ! empty( $new_instance['show_details'] ) ) ? $new_instance['show_details'] == TRUE : FALSE;

        return $instance;
    }
};

function register_server_status_widget() {
    register_widget( 'DediServerStatusWidget' );
}
add_action( 'widgets_init', 'register_server_status_widget' );

// Register shortcode for server list
function serverlist_func($atts) {
    $widgets = get_option('widget_server_status_widget');
    foreach($widgets as $id=>$w) {
        the_widget('DediServerStatusWidget', $w, array('id' => 'server-list-sidebar', 'widget_id' => $id));
    }
}
add_shortcode('serverlist', 'serverlist_func');